



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>浅谈iOS中MVVM的架构设计</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">浅谈iOS中MVVM的架构设计</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 14:30:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　<code>MVVM</code>就是在<code>MVC</code>的基础上分离出业务处理的逻辑到<code>viewModel</code>层。</p>
<p>　　M: &nbsp;Model层是API请求的原始数据，充当DTO(数据传输对象)，当然，用字典也是可以的，编程么，要灵活一些。Model层是比较薄的一层。</p>
<p>　　V: &nbsp;View层，视图展示，由<code>viewController</code>来控制，他的任务就是从ViewModel层获取数据，然后显示。</p>
<p>　　VM: &nbsp;ViewModel层负责业务处理和数据转化，就是View和Model层的粘合剂，他是一个放置用户输入验证逻辑，视图显示逻辑，发起网络请求和其他各种各样的代码的极好的地方。说白了，就是把原来ViewController层的业务逻辑和页面逻辑等剥离出来放到ViewModel层。</p>
<p>简单来说，就是API请求完数据，解析成<code>model</code>，之后在<code>viewModel</code>中转化成能够直接被视图层使用的数据，交付给前端。<code><br /></code></p>
<h4>model层</h4>
<p>我们先从model层开始，在这里我们用JSONModel来解析，比如一个商品列表的model长这样：</p>
<p><code>这是我们的数据原型，API返回的数据通过JSONModel解析完成后的原始数据存在这里。</code></p>
<div>
<pre class="prettyprint linenums">#import &lt;JSONModel/JSONModel.h&gt;<br />
@protocol LVMProductListModel &lt;NSObject&gt;<br />
@end

// productList<br />
@interface LVMProductListModel : JSONModel<br />
@property (nonatomic, copy) NSString *imgUrl;<br />
@property (nonatomic, copy) NSString *productId;<br />
@property (nonatomic, copy) NSString *productName;<br />
@property (nonatomic, copy) NSString *refPrice;<br />
@end</pre>
</div>
<h4>viewModel 层</h4>
<p>viewModel层是我们处理业务逻辑的核心层，在这里我们需要发起网络请求（如果网络请求较多，可以抽出来，只在ViewModel里调用）、解析数据、转换数据给前端。</p>
<div>
<pre class="prettyprint linenums">#pragma mark - Public Methods<br />
- (void)lvm_startLoadProductListWithPage:(NSInteger)page {<br />
  __weak typeof(self) weakSelf = self;<br />
  [NetWorkManager GET:self.lvm_baseURL<br />
                   parameters:parameters<br />
                        success:^(NSURLSessionDataTask *task, id responseObject) {<br />
    __strong typeof(weakSelf) strongSelf = weakSelf;<br />
    ...<br />
    NSDictionary *resultDic = responseObject[@"rp_result"];<br />
    NSError *error = nil;<br />
    LVMProductListModel *model = [[LVMProductListModel alloc] initWithDictionary:resultDic error:&amp;error];<br />
    if (error) {<br />
      ...<br />
    }<br />
    [strongSelf _lvm_calProductLists:model.productlist];<br />
    if (strangles.delegate ...) {<br />
       ...<br />
    }<br />
  } failure:^(NSURLSessionDataTask *task, NSError *error) {<br />
    ...<br />
  }];<br />
}

- (void)_lvm_calProductLists:(NSArray *)productLists{<br />
  for (NSInteger i = ; i &lt; productLists.count; ++i) {<br />
    LVMProductListModel *model = productLists[i];<br />
    LVMProductListItem *item = [[LVMProductListItem alloc] init];<br />
    item.lvm_productId = model.productId;<br />
    item.lvm_productName = model.productName;<br />
    item.lvm_productPrice = [NSString stringWithFormat:@"￥ %@", model.refPrice];<br />
    item.lvm_productImgURL = [Utils convertToRealUrl:model.imgUrl ofsize:];<br />
    [self.lvm_productLists addObject:item];<br />
  }<br />
}</pre>
</div>
<p>在<code>viewModel</code>中将API返回的数据解析成<code>model</code>，并将<code>model</code>转化成可供<code>view</code>层直接使用的<code>item</code>，将<code>item</code>交付给前端使用。</p>
<p>经过<code>viewModel</code>转化之后的数据<code>item</code>由<code>viewModel</code>保存，与数据相关的处理都将在<code>viewModel</code>中处理。<code>viewModel</code>返回给<code>view</code>层的接口长这样：</p>
<div>
<pre class="prettyprint linenums">@interface LVMProductListViewModel (CollectionViewDataSource)<br />
- (NSInteger)lvm_numberOfItemsInSection:(NSInteger)section;<br />
- (LVMProductListItem *)lvm_itemForIndexPath:(NSIndexPath *)indexPath;<br />
@end</pre>
</div>
<h4>view层</h4>
<p><code>view</code>层是由<code>viewController</code>控制的。<code>view</code>层只做展示，不做业务处理。<code>view</code>层的数据由<code>viewModel</code>提供。<code>view</code>层看起来是这样的：</p>
<div>
<pre class="prettyprint linenums">@implementation LVMProductListViewController

- (void)viewDidLoad {<br />
  [super viewDidLoad];<br />
  self.view.backgroundColor = [UIColor whiteColor];<br />
  [self _lvm_initial];<br />
  [self _lvm_setupViewModel];<br />
  [self _lvm_setupSubViews];<br />
  [self.lvm_viewModel lvm_startLoadProductListWithPage:_lvm_currentPage];<br />
}

- (void)_lvm_initial {<br />
  ...<br />
  self.lvm_currentPage = ;<br />
}

- (void)_lvm_setupViewModel {<br />
  self.lvm_viewModel = [[LVMProductListViewModel alloc] init];<br />
  _lvm_viewModel.lvm_delegate = self;<br />
}

#pragma mark - Subviews -<br />
- (void)_lvm_setupSubViews {<br />
  ...<br />
  [self _lvm_setupCollectionView];<br />
  ...<br />
}

- (void)_lvm_setupCollectionView {<br />
   ...<br />
}

#pragma mark - UICollectionView Delegate &amp; Datosource<br />
- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {<br />
  return [self.lvm_viewModel lvm_numberOfItemsInSection:section];<br />
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {<br />
  LVMProductListItem *item = [self.lvm_viewModel lvm_itemForIndexPath:indexPath];<br />
  LVMProductListCollectionViewCell *cell = (LVMProductListCollectionViewCell *)[collectionView dequeueReusableCellWithReuseIdentifier:kLVMProductListCollectionViewCellId forIndexPath:indexPath];<br />
  [cell lvm_setupWithItem:item];<br />
  return cell;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z1od19.html">iOS中多线程的实现方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwd4mr8.html">kubernetes 文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96ye3y8.html">【转】JSch - Java实现的SFTP（文件上传详解篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdrw478.html">Cwinux源码解析（五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rm64e8.html">安装vmall5：从ebak恢复数据，需要配置php&period;ini</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z14orn9.html">cdev&lowbar;系列函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd5ydgq.html">&lbrack;MySql&rsqb; 设置了UTF8，中文存数据库中仍然出现问号</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7md3lgq.html">jQuery基础学习3&mdash;&mdash;jQuery库冲突</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm6wk09.html">chart&period;js 示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rde1w78.html">开源欣赏wordpress之文章新增页面如何实现。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj141k9.html">CENTOS7小注意</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg1n3d8.html">蓝桥杯-无穷分数-java</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjerjr8.html">Redis--配置密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j11e049.html">VMware安装xp虚拟机</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvkrmg8.html">vim的基本用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvgg4z8.html">&lbrack;CodeForces - 447C&rsqb; C - DZY Loves Sequences</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em14mj9.html">【bzoj2877】 Noi2012&mdash;魔幻棋盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2on7z8.html">Django之分页功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4gvx5q.html">75&period; ID重新走过，备份表</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk2e018.html">使用 Eclipse 远程调试 Java 应用程序</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qve1mjo9.html">android 桌面小工具（Widget）开发教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rngr34q.html">梯度消失（vanishing gradient）与梯度爆炸（exploding gradient）问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kopxmrq.html">JavaScript 闭包（个人理解）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpe2n49.html">在线创建springboot项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/93py5yn8.html">ionic3中创建pipe管道</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmzkog9.html">ZH奶酪：如何在Ubuntu上安装Java&sol;管理多个JAVA&sol;设置JAVA&lowbar;HOME</a>
			</li>
						<li><a href="https://www.batexi.com/a/93py0kz8.html">Python&plus;H5py实现将SVHN样本库转换为FasterRcnn训练样本</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1jzz69.html">Java本地运行中文正常，部署到Weblogic中文乱码</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkyggv8.html">Spring-boot 1&period;5&period;2 下隐藏Banner</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj2m4p8.html">SQLServer中char、varchar、nchar、nvarchar的区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
